package com.unipi.talepis.demo5679;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;

import android.Manifest;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.View;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity implements LocationListener {
    final static int REQ_CODE = 765;
    TextView textView;
    LocationManager locationManager;
    Tts tts;
    SQLiteDatabase db;
    SharedPreferences preferences;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        textView = findViewById(R.id.textView);
        locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
        tts = new Tts(this);

        preferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());

        //Έτσι διαβάζω
        String s = preferences.getString("str25","No value yet");
        textView.setText(s);

        //Έτσι γράφω
        SharedPreferences.Editor editor = preferences.edit();
        editor.putString("str25","Efthimios Alepis");
        editor.apply();

        db = openOrCreateDatabase("DemoUsers",MODE_PRIVATE,null);
        db.execSQL("CREATE TABLE IF NOT EXISTS 'USER'(" +
                "'USER_ID' TEXT," +
                "'USER_NAME' TEXT," +
                "'USER_TEL' TEXT," +
                "PRIMARY KEY('USER_ID'))");
        db.execSQL("INSERT OR IGNORE INTO 'USER' VALUES" +
                "('1','Efthimios','2104142311')");
        db.execSQL("INSERT OR IGNORE INTO 'USER' VALUES" +
                "('2','Maria','2104142000')");
    }

    public void go1(View view){
        StringBuilder builder = new StringBuilder();
        Cursor cursor = db.rawQuery("SELECT * FROM USER",null);
        if (cursor.getCount()!=0){
            while (cursor.moveToNext()){
                builder.append(cursor.getString(0)+"\n");
                builder.append(cursor.getString(1)+"\n");
                builder.append(cursor.getString(2)+"\n");
                builder.append("-----------------------------\n");
            }
            //textView.setText(builder.toString());
            showMessage(builder.toString());
        }
    }

    public void go2(){
        /*db.execSQL("Update 'User'.....");
        -//- Delete
        -//-- Insert*/
    }

    public void saysomething(View view){
        tts.speak("Hello Students of Informatics!");
    }

    public void showMessage(String message){
        new AlertDialog.Builder(this)
                .setTitle("Records:")
                .setMessage(message)
                .setCancelable(true)
                .show();
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        //locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER,0,0,this);
    }

    public void runpermission(View view){
        if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION)!=
        PackageManager.PERMISSION_GRANTED){
            ActivityCompat.requestPermissions(this,
                    new String[]{Manifest.permission.ACCESS_FINE_LOCATION},REQ_CODE);
        }else {
            locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER,0,0,this);
        }
    }

    @Override
    public void onLocationChanged(Location location) {
        textView.setText(String.valueOf(location.getLatitude())+","+String.valueOf(location.getLongitude()));

    }

    @Override
    public void onStatusChanged(String provider, int status, Bundle extras) {

    }

    @Override
    public void onProviderEnabled(String provider) {

    }

    @Override
    public void onProviderDisabled(String provider) {

    }
}
